#!/usr/bin/python
# -*- coding:utf-8 -*-

from dom import *
import scorecard
import makelogo

#def newInstance():
#    return None
#    return MLB_ESPN2005()

class MLB_ESPN2005 ( scorecard.ScoreCard ):
    def __init__( self ):
        scorecard.ScoreCard.__init__( self )
        self.date = None
        self.games = []
        return
        
    def getName( self ):
        return "MLB (ESPN)"

    def getVersion( self ):
        return "1.0"

    def getSportsCategory( self ):
        return "baseball"

    def getCountry( self ):
        return "USA"

    def getURL( self ):
        return "http://sports.espn.go.com/mlb/scoreboard"

    def decode( self, contents ):
        return contents
    #import re
    #    contents = re.sub( "<!--.{0,10}-->", "", contents )
    #    contents = re.sub( "alt=[^\"]([^\\\"\\s>]+)", "", contents )
    #    return unicode( contents, self.getEncoding() ).encode( 'utf-8' )
    def getEncoding( self ):
        return 'ascii'

    def getStartKeyword( self ):
        return "<!-- begin AL column -->"
        #return None
        #return "<!---/SCHEDULE NAVI--->"

    def getEndKeyword( self ):
        return "<!-- end NL column -->"
        #return None
        #return "<hr size=1>"#"免責事項"#"<!-- Start of Footer -->"

    def getIcon( self, team ):
        return ""
        if team == "中日":          name = "d"
        elif team == "ヤクルト":     name = "s"
        elif team == "巨人":        name = "g"
        elif team == "阪神":        name = "t"
        elif team == "広島":        name = "c"
        elif team == "横浜":        name = "yb"
        elif team == "西武":        name = "l"
        elif team == "ソフトバンク": name = "h"
        elif team == "日本ハム":     name = "f"
        elif team == "ロッテ":      name = "m"
        elif team == "オリックス":   name = "bs"
        elif team == "楽天":        name = "e"
        try:
            uri = makelogo.getURI( 'http://www.npb.or.jp/images/npb/pet40inter_%s.gif' % name, 'npb', name, transparency=False )
            return '<td class="teamlogo"><img src="%s" class="logo"/></td>' % uri
        except Exception, e:
            raise
            return ''
        pass


    def resolve_game( self, element ):
        elem_status = element.get_element_at_path( "tr/td/table/tr,2" )
        status = elem_status.get_text()
        elem_game = elem_status.next_sibling()
        team1 = elem_game.get_element_at_path( "th/span" ).get_text()
        goal1 = elem_game.get_element_at_path( "th,2" ).get_text()
        goal2 = elem_game.get_element_at_path( "th,4" ).get_text()
        team2 = elem_game.get_element_at_path( "th,5/span" ).get_text()
        return [ team1, team2, goal1, goal2, status ]

    def interpreteDocument( self, document ):
        import re, sys
        print document
        sys.exit()
        #print document
        elem_res = document.get_element_at_path( "/html/table/tr/td/table/tr/td/table/tr,2/td,2/a" )
        if elem_res:
            try:
                href = elem_res.get_attribute( 'href' ).strip( ' /' ).split( '/' )
                self.date = href[ -1 ][ 0: 4 ] + '/' + href[ -1 ][ 4: 6 ] + '/' + href[ -1 ][ 6 : 8 ]
            except:
                self.date = None
                pass
            pass
        #title = document.get_element_at_path( "/html/head/title" )
        #self.date = title
        elem_game = document.get_element_at_path( "/html/table/tr/td/table/tr" )
        while elem_game:
            try:
                elem = elem_game.get_element_at_path( "td/table/tr/td" )
                team1 = elem.get_text()
                elem = elem.next_sibling( 'td' )
                scores = re.split( "\\D+", elem.get_text() )
                score1 = scores[ 0 ]
                score2 = scores[ 1 ]
                elem = elem.next_sibling( 'td' )
                team2 = elem.get_text()
                self.games.append( ( team1, team2, score1, score2 ) )
            except:
                pass
            #print elem_game.get_element_at_path( "t" )
            #print elem_game.get_element_at_path( 'tr/td/table/tr/td' )
            try:
                elem_game = elem_game.next_sibling()
            except:
                break
            pass
        return
        #print elem_game.next_sibling()
        sys.exit()
        elem_date = document.get_element_at_path( "/html/table/tr,3/td/table/tr/td,3" )
        elem_date = document.get_element_at_path( "/html/table/tr,3/td/table/tr/td" )
        while elem_date != None:
            text = elem_date.get_text( " " )
            if re.search( "\\d+/\\d+/\\d+", text ):
                self.date = text
                break
            try:
                elem_date = elem_date.next_sibling( 'td' )
            except:
                break
            pass

        elem = document.get_element_at_path( "/html/div/table/tr/td" )
        e = elem.get_element_at_path( 'table' )
        while e != None:
            gamestatus = self.resolve_game( e )
            if gamestatus != None:
                self.games.append( gamestatus )
                pass
            try:
                e = e.next_sibling( 'table' )
            except:
                break
            pass
        return

    def getDate( self ):
        if not self.date:
            return ""
        return self.date

    def toHTML( self ):
        html = self.html_header()
        html += '<title>%s</title>' % ( self.getName() )
        html += "<body>"
        if len( self.games ) > 0:
            html += '<span id="tabletitle">%s %s</span>' % ( self.getName(), self.getDate() )
            html += "<table>"
            for game in self.games:
                lastcolumn = ""
                if len( game ) > 4:
                    lastcolumn = '<td class="status">%s</td>' % game[ 4 ]
                    pass
                team1 = self.getIcon( game[ 0 ] ) \
                        + '<td class="team">%s</td>' % game[ 0 ]
                team2 = '<td class="team">%s</td>' % game[ 1 ] \
                        + self.getIcon( game[ 1 ] )
                html += '<tr>%s<td class="score">%s - %s</td>%s%s</tr>\n' % ( team1, game[ 2 ], game[ 3 ], team2, lastcolumn )
                pass
            html += "</table>"
        else:
            html += "<div id=\"error\">データの取得に失敗しました</div>"
            pass
        html += "</body>"
        html += self.html_footer()
        return html        
    pass

if __name__ == "__main__":
    from loader import *
    obj = JLeagueDivisionOneNS2005()

    if obj != None and obj.isAvailable():
        url = obj.getURL()
        data = unicode( loadHTML_test( "../html/j1-2.html" ), obj.getEncoding() ).encode( 'utf-8' )
        kw_start = obj.getStartKeyword()
        kw_end   = obj.getEndKeyword()
        parser = DOMConverter()
        if kw_start == None or kw_end == None:
            parser.feed( data )
            pass
        else:
            flag_inside = False
            parser.feed( '<html>' )
            for line in re.split( "\n", data ):
                line = line.strip()
                if flag_inside:
                    if line == kw_end: flag_inside = False
                    else: parser.feed( line )
                elif line == kw_start: flag_inside = True
                pass
            parser.feed( '</html>' )
            pass
        document = parser.get_document()
        obj.interpreteDocument( document )
        print obj.toHTML()
        #file_out = open( filename_output, "w" )
        #file_out.write( obj.toHTML() )
        #file_out.close()
        #uri = "file://%s" % filename_output
        #print uri
        pass
    pass


#data = unicode( open( "../html/j1.html" ).readlines().join( "" ), 'sjis' )
    
